/*
 *  linux/kernel/asm.s
 *
 *  (C) 1991  Linus Torvalds
 */

/*
 * asm.s contains the low-level code for most hardware faults.
 * page_exception is handled by the mm, so that isn't here. This
 * file also handles (hopefully) fpu-exceptions due to TS-bit, as
 * the fpu must be properly saved/resored. This hasn't been tested.
 */
/*
 * asm.s а󲿷ֵӲϣĵײδ롣ҳ쳣ڴ
 * mm ģԲ˳򻹴ϣTS-λɵfpu 쳣
 * Ϊfpu ȷؽб/ָЩûвԹ
 */
 
# ļҪ漰Intel жint0--int16 Ĵint17-int31 ʹã
# һЩȫֺԭtraps.c ˵
.globl _divide_error,   _debug,   _nmi,    _int3,       _overflow,_bounds,_invalid_op
.globl _double_fault,   _coprocessor_segment_overrun
.globl _invalid_TSS,    _segment_not_present,           _stack_segment
.globl _general_protection,  _coprocessor_error,_irq13, _reserved

# γ޳
# int0--  ͣ󣻴ţ
# ִ DIV  IDIV ָʱ 0CPU ͻ쳣 EAX AX , AL)ɲ
# һϷĽʱҲ쳣š_do_divide_errorʵ C Ժ
# do_divide_error()ģжӦĺdo_divide_errortrap.cʵ

_divide_error:
	pushl $_do_divide_error		# ȰѽҪõĺַջγĳΪ0
no_error_code:					# ޳Ŵڴ
	xchgl %eax,(%esp)			# _do_divide_error ĵַ -> eaxeax ջ
	pushl %ebx
	pushl %ecx
	pushl %edx
	pushl %edi
	pushl %esi
	pushl %ebp
	push %ds					# 16 λĶμĴջҲҪռ4 ֽڡ
	push %es
	push %fs
	pushl $0	# "error code"  # ջ
	lea 44(%esp),%edx			# ȡԭ÷صַջָλãѹջ
	pushl %edx
	movl $0x10,%edx				# ʼμĴں˴ݶѡ
	mov %dx,%ds
	mov %dx,%es
	mov %dx,%fs
	call *%eax					# C do_divide_error()
	addl $8,%esp				# ൱ִpopջ C 
								# öջָָĴfs ջ
	pop %fs
	pop %es
	pop %ds
	popl %ebp
	popl %esi
	popl %edi
	popl %edx
	popl %ecx
	popl %ebx
	popl %eax					# ԭeax еݡ	
	iret

# int1 -- debug жڵ㡣ͬϡ
_debug:
	pushl $_do_int3		# _do_debug
	jmp no_error_code

# int2 -- жϵڵ㡣
_nmi:
	pushl $_do_nmi
	jmp no_error_code

# int3 -- ϵָжϵڵ
_int3:
	pushl $_do_int3
	jmp no_error_code

# int4 -- жڵ㡣
_overflow:
	pushl $_do_overflow
	jmp no_error_code

# int5 -- ߽жڵ㡣
_bounds:
	pushl $_do_bounds
	jmp no_error_code

# int6 -- Чָжڵ㡣
_invalid_op:
	pushl $_do_invalid_op
	jmp no_error_code

# int9 -- Эγжڵ㡣
_coprocessor_segment_overrun:
	pushl $_do_coprocessor_segment_overrun
	jmp no_error_code

# int15 C 
_reserved:
	pushl $_do_reserved
	jmp no_error_code

# int45 -- ( = 0x20 + 13 ) ѧЭCoprocessorжϡ
# ЭִһʱͻᷢIRQ13 жźţ֪ͨCPU ɡ
_irq13:
	pushl %eax
	xorb %al,%al				# 80387 ִмʱCPU ȴɡ
	outb %al,$0xF0				# ͨд0xF0 ˿ڣжϽCPU BUSY źţ
								# 80387 ĴչPEREQòҪΪȷ
								# ڼִ80387 κָ֮ǰӦжϡ
	movb $0x20,%al
	outb %al,$0x20				# 8259 жϿоƬEOIжϽźš
	jmp 1f						# תָʱá
1:	jmp 1f
1:	outb %al,$0xA0				# 8259 жϿоƬEOIжϽźš
	popl %eax
	jmp _coprocessor_error		# _coprocessor_error ԭڱļУѾŵsystem_call.s

# жڵʱжϷصַ֮󽫳ѹջ˷ʱҲҪŵ


_double_fault:
	pushl $_do_double_fault		# C ַջ
error_code:
	xchgl %eax,4(%esp)		# error code <-> %eax # error code <-> %eaxeax ԭֵڶջϡ
	xchgl %ebx,(%esp)		# &function <-> %ebx  # &function <-> %ebxebx ԭֵڶջϡ
	pushl %ecx
	pushl %edx
	pushl %edi
	pushl %esi
	pushl %ebp
	push %ds
	push %es
	push %fs
	pushl %eax				# error code  # ջ
	lea 44(%esp),%eax		# offset	  # 򷵻صַջָλֵջ
	pushl %eax
	movl $0x10,%eax			# ںݶѡ
	mov %ax,%ds
	mov %ax,%es
	mov %ax,%fs
	call *%ebx				# ӦC ջ
	addl $8,%esp			# ջָָջзfs ݵλá
	pop %fs
	pop %es
	pop %ds
	popl %ebp
	popl %esi
	popl %edi
	popl %edx
	popl %ecx
	popl %ebx
	popl %eax
	iret

# int10 -- Ч״̬(TSS)
_invalid_TSS:
	pushl $_do_invalid_TSS
	jmp error_code

# int11 -- βڡ
_segment_not_present:
	pushl $_do_segment_not_present
	jmp error_code

# int12 -- ջδ
_stack_segment:
	pushl $_do_stack_segment
	jmp error_code

# int13 -- һ㱣Գ
_general_protection:
	pushl $_do_general_protection
	jmp error_code


# int7 -- 豸(_device_not_available)(kernel/system_call.s)
# int14 -- ҳ(_page_fault)(mm/page.s)
# int16 -- Э(_coprocessor_error)(kernel/system_call.s)
# ʱжint 0x20 (_timer_interrupt)(kernel/system_call.s)
# ϵͳint 0x80 (_system_call)ڣkernel/system_call.s
